////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI Industrial Card VC++ 6.0 Sample (DII)
//
// # Used Library: Dynamic Industrial Interface (DII)
//
// # Designer:   Jason Hong         2004/06/18
//
////////////////////////////////////////////////////////////////////

// PCIIND_TESTDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCIIND_TEST.h"
#include "PCIIND_TESTDlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCIIND_TESTDlg dialog

CPCIIND_TESTDlg::CPCIIND_TESTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCIIND_TESTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCIIND_TESTDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCIIND_TESTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCIIND_TESTDlg)
	DDX_Control(pDX ,IDC_BUTTON65,msg1 );
	DDX_Control(pDX ,ID_AUTO , m_autorun);
	
	DDX_Control(pDX ,IDC_RADIO1 , m_Auto);
	DDX_Control(pDX ,IDC_RADIO2 , m_Manual);
	

	DDX_Control(pDX, IDC_SLIDER1, m_slider_ctrl);
		// NOTE: the ClassWizard will add DDX and DDV calls here


	for(int i = 0 ; i<64 ; i++)
       DDX_Control(pDX, IDC_CHECK1+i, allchannel[i]) ;


	//}}AFX_DATA_MAP
	
}

BEGIN_MESSAGE_MAP(CPCIIND_TESTDlg, CDialog)
	//{{AFX_MSG_MAP(CPCIIND_TESTDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_AUTO, OnAutorun)
	ON_BN_CLICKED(IDC_RADIO1, Check_Auto)
	ON_BN_CLICKED(IDC_RADIO2, Check_Manual)
	ON_WM_TIMER()
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK64,ManualTest)
	//}}AFX_MSG_MAP
	

END_MESSAGE_MAP()
	
	
/////////////////////////////////////////////////////////////////////////////
// CPCIIND_TESTDlg message handlers

BOOL CPCIIND_TESTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

//**********************************************************************
	manualTorF=false;
	m_bstate = false;
	m_Auto.SetCheck(true);

	BOOL init;
	BOOL temp;
	BYTE byState;
	char DevName[200];
	CString str;
	m_autorun.EnableWindow(false);
	m_Auto.EnableWindow(false);
	m_Manual.EnableWindow(false);

    init = DiiSelectDevice(NULL, DevName, 210);

	if (init == false)
		msg1.SetWindowText("Can't find the port!");
	
	hDevice = DiiOpenNamedDevice(DevName, true);	

	if (hDevice != INVALID_HANDLE_VALUE){
		msg1.SetWindowText( "Get card address success !!");
		temp = DiiSetDigitalByte(hDevice, 0, 0);
		temp = DiiGetDigitalByte(hDevice, 0, &byState);
		m_autorun.EnableWindow(true);
		m_Auto.EnableWindow(true);
		m_Manual.EnableWindow(true);
	}
	else{
		msg1.SetWindowText( "Get card address fail !!");
	}
	
	
	for(int j = 0 ; j<64 ;j++)
       allchannel[j].EnableWindow(false);
		
	
	m_slider_ctrl.SetPos(m_slider_ctrl.GetRangeMax()/2); 
//**********************************************************************
	
	for(int i=0 ; i < 64 ; i++)
	  line[i] = false ;

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCIIND_TESTDlg::OnAutorun()
{

	m_bstate = !m_bstate;

	if(m_bstate)
	{
	  m_autorun.SetWindowText("Stop");
	  now_out_ch = 0 ;    //reset
	  now_out_line = 1 ;  //reset
      m_nTimer = SetTimer(1,500,0);

	}
	else
	{
  	  m_autorun.SetWindowText("Test");
      KillTimer(m_nTimer);
	}

}


void CPCIIND_TESTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCIIND_TESTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CPCIIND_TESTDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
   
	
	if(now_out_ch <= 3)     //channel 0 to 3
		  if(now_out_line <= 0x8000) //line 0 to 15 line
		  { 
			OneTimeSignalDisplay(now_out_ch,now_out_line, manualTorF);
			now_out_line = now_out_line << 1; 
			
			
			//because the max value of "m_slider_ctrl.GetPos()" is 100
			//		  the min ...								is 0	
			SetTimer( 1 , m_slider_ctrl.GetPos()*10 , 0 );
		  
		  }
		  else
		  { 
			now_out_line = 1 ; 
			now_out_ch++; 
		  }
	else
	  now_out_ch = 0;
	


	CDialog::OnTimer(nIDEvent);
}

void CPCIIND_TESTDlg::OneTimeSignalDisplay
     (unsigned short output_channel ,unsigned short output_line, bool manualTorF)
{   
	unsigned short out_value=0, in_value=0 ;
    unsigned short out = 1, in = 1 ;
	unsigned short input_channel, input_line ; 
    input_channel = 3-output_channel ;
		
	unsigned short  pre_outline;


	DiiGetDigitalWord(hDevice , output_channel ,&pre_outline );
	DiiSetDigitalWord(hDevice , input_channel , 0xffff);
		
	if(manualTorF)
	{     
	  output_line = pre_outline ^ output_line;

	  DiiSetDigitalWord( hDevice , output_channel , output_line);
	  DiiGetDigitalWord( hDevice , input_channel , &input_line);

	  
      
	  for(int bit=0;bit<=15;bit++)
	  {
        if(((output_line>>bit)&0x0001)==1)	
		    out_value= out_value + out ; 

		if(((input_line>>bit)&0x0001)==1)
		{
			allchannel[input_channel * 16 + bit].SetCheck(BST_CHECKED);
			line[input_channel * 16 + bit] = true ;
			in_value= in_value + in ;
	
			
				
		}
		else
		{
			allchannel[input_channel * 16 + bit].SetCheck(BST_UNCHECKED);
			
			line[input_channel * 16 + bit] = false ;


		
		}
		out = out * 2 ;
		in = in * 2 ;
	  }
	}
	else  //auto mode 
	{

      DiiSetDigitalWord(hDevice , output_channel, output_line);
	  DiiGetDigitalWord(hDevice , input_channel , &input_line);

	

	  
	  for(int bit=0;bit<=15;bit++)
	  { 
		if(((output_line>>bit)&0x0001)==1)
		{	
			allchannel[output_channel * 16 + bit].SetCheck(BST_CHECKED); 
		    out_value= out_value + out ; 
		}   
		else
			allchannel[output_channel * 16 + bit].SetCheck(BST_UNCHECKED);
		

		if(((input_line>>bit)&0x0001)==1)
		{	
			allchannel[input_channel * 16 + bit].SetCheck(BST_CHECKED);
			in_value= in_value + in ;
		}
		else
			allchannel[input_channel * 16 + bit].SetCheck(BST_UNCHECKED);  
		
		out = out * 2 ;
		in = in * 2 ;
	  }
	} 

	


    CString str;
	text = (CStatic*) GetDlgItem(IDC_OUTPUT);
	str.Format("Channel[%d]: %7d",output_channel,out_value);  
	text->SetWindowText(str);
	text = (CStatic*) GetDlgItem(IDC_INPUT);
	str.Format("Channel[%d]: %7d",input_channel,in_value);  
	text->SetWindowText(str);



}

void CPCIIND_TESTDlg::Check_Manual( )
{

	manualTorF=true;
	KillTimer(m_nTimer);

	m_autorun.EnableWindow(false);

	for(int i = 0 ; i<64 ; i++)
	{
		allchannel[i].SetCheck(false); 
		allchannel[i].EnableWindow(true);
	}
	
	for(int j = 0 ; j<4 ; j++)		
	{
	DiiSetDigitalWord(hDevice , j, 0);
	}

}



void CPCIIND_TESTDlg::Check_Auto()
{

	manualTorF=false;
	m_autorun.EnableWindow(true);
	

	for(int i = 0 ; i<64 ; i++)
	{	
		allchannel[i].SetCheck(false); 
		allchannel[i].EnableWindow(false);
	}

       
}


void CPCIIND_TESTDlg::ManualTest(UINT idButton)
{
	if (manualTorF==true)
	{
	
	idButton = idButton-IDC_CHECK1 ;

	line[idButton] = !line[idButton] ;

	unsigned short ch_num = (idButton)/16 ;
    unsigned short shift =  (idButton)%16;
    unsigned int ch_line = 1;
	ch_line = ch_line << shift;
    OneTimeSignalDisplay(ch_num ,ch_line, manualTorF);
	
	
	}


}


